static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xE4, 0x97, 0x5D, 0x43, 0xF0, 0x67, 0x6F, 0x84, 0x5E, 0x12,
        0x9F, 0x28, 0x6A, 0x3D, 0x29, 0x63, 0x91, 0x12, 0x21, 0x8C,
        0x54, 0x18, 0x15, 0x41, 0x92, 0xD2, 0xEF, 0x1D, 0x51, 0x45,
        0x5D, 0x32, 0xDB, 0xB4, 0x79, 0xB8, 0xD9, 0xCE, 0x6A, 0x3D,
        0x4D, 0x6D, 0xE3, 0x1D, 0x46, 0x08, 0xEB, 0x1D, 0x70, 0xA8,
        0x73, 0x67, 0x03, 0x90, 0x99, 0xAE, 0xF9, 0xFE, 0xCC, 0x93,
        0x56, 0xF2, 0xF6, 0x9B
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
